 

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ESRI.ArcGIS.Mobile;
using ESRI.ArcGIS.Mobile.Geometries;
using ESRI.ArcGIS.Mobile.MapActions;
using ESRI.ArcGIS.Mobile.MobileServices;

namespace MobilePocketPCApp
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void Form1_Load(object sender, EventArgs e)
    {
      // Set the cachestorage location on disk
      mobileCache1.StoragePath = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\MapCache";

      if (!mobileCache1.IsValid)
      {
        MessageBox.Show("Map Cache is not valid!");
        return;
      }
      if (mobileCache1.IsEmpty)
      {
        try
        {
          // Uncomment the following line and replace URL with your own mobile service if you
          // decide to use your own Mobile service map data
          //mobileServiceConnection1.Url = @"http://YourServer/YourArcGISServerInstance/services/YourMobileServiceName/MapServer/MobileServer";
          //mobileCache1.DeleteCache();
          MobileCacheSyncAgent mobilesync = new MobileCacheSyncAgent(mobileCache1, mobileServiceConnection1);
          //MobileCacheSyncResults mobileResults = new MobileCacheSyncResults();
          mobileCache1.Open();
          //mobilesync.Synchronize();

        }
        catch
        {
          MessageBox.Show("Cannot synchronize with this service");
        }
      }
      try
      {
        mobileCache1.Open();
        map1.DataSources.Add(mobileCache1);

      }
      catch
      {
        MessageBox.Show("Cannot open map cache");
      }
        
    }

   

    private void menuItem2_Click(object sender, EventArgs e)
    {
      map1.CurrentMapAction = zoomInMapAction1;
    }

    private void menuItem3_Click(object sender, EventArgs e)
    {
      map1.CurrentMapAction = zoomOutMapAction1;
    }

    private void menuItem4_Click(object sender, EventArgs e)
    {
      map1.CurrentMapAction = panMapAction1;
    }

    private void menuItem5_Click(object sender, EventArgs e)
    {
      map1.CurrentMapAction = null;
    }

    private void map1_MouseDown(object sender, MapMouseEventArgs e)
    {
      //If MapAction is set to null then do identify
      if (map1.CurrentMapAction != null)
        return;
      // Tis code is used to identify the selected feature(s)
      Cursor.Current = Cursors.WaitCursor;
      MapMouseEventArgs me = e as MapMouseEventArgs;
      Envelope qEnv = new Envelope(me.MapCoordinate, me.MapCoordinate);

      double mapTolerance = map1.ToMap(3);
      qEnv.Resize(mapTolerance, mapTolerance);

      QueryFilter qFilter = new QueryFilter(qEnv, GeometricRelationshipType.Intersect);

      string txtResult = "Identify Results: ";
      int intFields;

      {
        foreach (MobileCacheLayer MCLayer in mobileCache1.Layers)
        {
          //Only Feature layers are used in identify 
          if (MCLayer is FeatureLayer)
          {
            txtResult += "\r\n Layer " + MCLayer.Name;
            FeatureLayer FLayer;
            //cast the MobileServiceLayer to a featureLayer
            FLayer = (FeatureLayer)MCLayer;
            using (FeatureDataReader featReader = FLayer.GetDataReader(qFilter))
            {
              intFields = featReader.FieldCount;
              while (featReader.Read())
              {
                for (int i = 0; i < intFields; i++)
                  txtResult += "\r\n" + featReader.GetName(i) + ": " + featReader.GetValue(i).ToString();
              }
            }
          }
        }
      }
      Cursor.Current = Cursors.Default;
      MessageBox.Show(txtResult.ToString());

    }

   		
  }
 }

